/*==========================================================================
 *
 *  Copyleft (C) 2004 Interactive Computer Graphics. All Rights "UN-Reserved".
 *
 *  File:       MyModel.h
 *  Content:    Header file of MyModel.cpp with a simple class to load a 3D model
 * 
 *	2001/10/5	Modified by Alex Ma
 *				1.	Add some chinese comments
 *				2.	Add a code section about how to do direct memory access
 *	2004/09/22  Modified by Kinomoto
 *				1.  Rearrange code structure
 *              2.  Add a TRI importer class
 ***************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <io.h>
#include <string.h>
#include <windows.h>
#include <windowsx.h>

#ifndef MY_MODEL
#define MY_MODEL
//---------------------------------------------------------------------------
typedef struct VERTEX
{
        float x,y,z;
} MyVector;
typedef struct TRIANGLE
{
        int VIndex[3];
        int NIndex[3];
        unsigned char ForeColor[3],BackColor[3];
} MyFace;
//---------------------------------------------------------------------------
class MyModel{
public:
        int mode;                               //Model file type
                                                //0 : No data
                                                //1 : TRI
        char FileName[255];                     //filename of the model
        long ModelSize;                         //Size of the model file(bytes)
        int NumVertex,NumNormal,NumFace,NumPart;//Statis of Model
        MyVector Min,Max;                       //Bounding box
        MyVector Center;                        //Center of the model
                                                // use half of the bounding box
                                                // as the center
        MyVector *VertexList;                   //Array of vertex
        MyVector *NormalList;                   //Array of normals
        MyFace   *FaceList;                     //Array of faces
        bool LoadTri(const char*);		//Load Tri File
        bool SaveTri(const char*);   		//Save Tri File
        void Stat();                 		//Count function
        bool Unload();               		//Unload model file

        MyModel();                   //Constructor
        ~MyModel();                  //Destructor
};

enum{
	MODEL_NONE	= 0,
	MODEL_TRI	= 1,
};

#endif